n, q, k = map(int, input().split())
priorities = list(map(int, input().split()))
tasks = [(priorities[i], i) for i in range(n)]
for _ in range(q):
    l, r = map(int, input().split())
    for i in range(l - 1, r):
        tasks[i] = (priorities[i], i)
tasks.sort()
result = tasks[k - 1][1] + 1
print(result)

